 #include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <unistd.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <pthread.h>
#include <string.h>
#include <signal.h>
#include <linux/unistd.h>
#include <syslog.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <dirent.h>
#include <sys/mman.h> 
#include <math.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <netdb.h>  
#include <sys/times.h>
#include <memory.h>


#define MAX_THREAD 10
#define REQ_BUFSIZE 4096

#define RDMA_PORT 7957
#define RETRY_ATTEMPTS 1000000000
#define SLEEP_TIME 1 

#ifndef TRUE
    #define TRUE 1 
#endif

#ifndef FALSE
    #define FALSE 0
#endif

#define CONTROL_BUF_SIZE 1024
 
#define VERBOSE_LEVEL 10

#define myprintf(lvl,fmt,args...) \
    do { \
		if (lvl <= VERBOSE_LEVEL) \
	    	print_info(fmt,##args); \
    } while (0)

typedef struct {
    int 			thread_id;
    int			fd;
    void 			*device_hndl;
} thread_info;

typedef struct {
	pthread_t	 		thread_id;	
	struct thread_list_t		*next;
	struct thread_list_t		*prev;
} thread_list_t;


typedef enum {
    SERVER_WRITE = 1,
    CLIENT_WRITE,
    SERVER_READ,
    CLIENT_READ,
    INVALID,
} transfer_mode_t;

typedef enum{
    OK = 200,
    FAIL = 404,
}response_t;

typedef enum{
    GET = 1,
    HEAD,
    PUT,
}command_t;

typedef struct {
    response_t response_type;
    char host[100];
    char stag[100];
    char to[100];
    char len[100];
    char rdma[100];
    char r_ip[100];
    char r_port[100];
    char content_len[100];
    int content_size;
    command_t command_type;
    char method[100];
}response_struct_t;




int read_to_boundary(int socket_fd, char *buf, int max_len);
int send_error(int socket_fd);
int get_filename(response_struct_t *cs, char *filename);
int send_success(int socket_fd, int resource_size);
transfer_mode_t get_mode(char *mode_string);
int tcp_send_file(int socket_fd, char *filename, int filesize);
inline int tcp_get_file(int socket_fd, char *filename, int filesize);
void print_info(const char *fmt, ...);





